﻿declare module 'cb-helpers' {
  import Q = require('q');
  type Tuple<T1, T2> = [T1, T2];
  type lineFn = (content?: string, charCount?: number) => void;
  type styleFn = (content: any) => string;
  type logFn = (...contents: any[]) => void;
  type logTitleFn = (title: any, ...contents: any[]) => void;
  type createTitleLoggerFn = (title: any) => logFn;

  namespace Helpers {
    function questionAsync(question: string): Q.Promise<string>;
    function yesNoAsync(question: string): Q.Promise<boolean>;
    function noYesAsync(question: string): Q.Promise<boolean>;
    function chooseFromAsync<T>(items: T[], question: string,
      map?: number | string | ((item: T) => any)): Q.Promise<Tuple<number, T>>;

    function br(lines?: number): void;
    const line: lineFn;
    const titleLine: lineFn;
    const titleStart: lineFn;
    const titleEnd: lineFn;

    const normal: styleFn;
    const info: styleFn;
    const danger: styleFn;
    const success: styleFn;
    const warning: styleFn;
    const symbol: styleFn;

    const logNormal: logFn;
    const logInfo: logFn;
    const logDanger: logFn;
    const logSuccess: logFn;
    const logWarning: logFn;
    const logSymbol: logFn;

    const logEvalInfo: logFn;
    const logEvalDanger: logFn;
    const logEvalSuccess: logFn;
    const logEvalWarning: logFn;

    const logInfoTitle: logTitleFn;
    const logDangerTitle: logTitleFn;
    const logSuccessTitle: logTitleFn;
    const logWarningTitle: logTitleFn;

    const logEvalInfoTitle: logTitleFn;
    const logEvalDangerTitle: logTitleFn;
    const logEvalSuccessTitle: logTitleFn;
    const logEvalWarningTitle: logTitleFn;

    const createInfoTitleLogger: createTitleLoggerFn;
    const createDangerTitleLogger: createTitleLoggerFn;
    const createSuccessTitleLogger: createTitleLoggerFn;
    const createWarningTitleLogger: createTitleLoggerFn;

    function logPromise<T extends PromiseLike<any>>(promise: T, promiseName: string): T;
  }

  export = Helpers;
}